import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.SwingConstants;
import javax.swing.JTextField;
import javax.swing.JLabel;
import java.awt.Font;
import java.awt.Color;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.ListSelectionModel;
import javax.swing.border.BevelBorder;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class Finestra {

	static private JFrame frame;
	static private JTextField textComboi;
	private JLabel lblSistemaDeSeguretat;
	private JLabel lblTemperatura;
	private JLabel lblLlum;
	private JLabel lblPorta;
	private JLabel lblAlarma;
	static private JTable table;
	private JLabel lblHora;
	private JLabel lblIdVago;
	private JButton btnNewButton;
	static private JTextField txtDades;
	static private JTextField textField_1;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Finestra window = new Finestra();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public Finestra() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		
		frame = new JFrame();
		frame.setBounds(100, 100, 840, 640);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);
		
		textComboi = new JTextField();
		textComboi.setText("");
		textComboi.setEditable(false);
		textComboi.setFont(new Font("Arial", Font.BOLD | Font.ITALIC, 15));
		textComboi.setHorizontalAlignment(SwingConstants.CENTER);
		textComboi.setBounds(108, 104, 90, 20);
		frame.getContentPane().add(textComboi);
		textComboi.setColumns(10);
		
		JLabel lblNewLabel = new JLabel("ID COMBOI");
		lblNewLabel.setFont(new Font("Arial", Font.BOLD | Font.ITALIC, 14));
		lblNewLabel.setHorizontalAlignment(SwingConstants.LEFT);
		lblNewLabel.setBounds(10, 104, 100, 20);
		frame.getContentPane().add(lblNewLabel);
		
		lblSistemaDeSeguretat = new JLabel("SISTEMA DE SEGURETAT I CONFORT FERROVIARI     -     ESTACI\u00D3");
		lblSistemaDeSeguretat.setHorizontalAlignment(SwingConstants.CENTER);
		lblSistemaDeSeguretat.setFont(new Font("Arial", Font.BOLD, 18));
		lblSistemaDeSeguretat.setBounds(10, 11, 803, 28);
		frame.getContentPane().add(lblSistemaDeSeguretat);
		
		lblTemperatura = new JLabel("TEMPERATURA");
		lblTemperatura.setHorizontalAlignment(SwingConstants.LEFT);
		lblTemperatura.setFont(new Font("Arial", Font.PLAIN, 13));
		lblTemperatura.setBounds(292, 135, 100, 20);
		frame.getContentPane().add(lblTemperatura);
		
		lblLlum = new JLabel("LLUM");
		lblLlum.setHorizontalAlignment(SwingConstants.CENTER);
		lblLlum.setFont(new Font("Arial", Font.PLAIN, 13));
		lblLlum.setBounds(391, 135, 100, 20);
		frame.getContentPane().add(lblLlum);
		
		lblPorta = new JLabel("PORTA");
		lblPorta.setHorizontalAlignment(SwingConstants.CENTER);
		lblPorta.setFont(new Font("Arial", Font.PLAIN, 13));
		lblPorta.setBounds(486, 135, 100, 20);
		frame.getContentPane().add(lblPorta);
		
		lblAlarma = new JLabel("ALARMA");
		lblAlarma.setHorizontalAlignment(SwingConstants.CENTER);
		lblAlarma.setFont(new Font("Arial", Font.PLAIN, 13));
		lblAlarma.setBounds(586, 135, 100, 20);
		frame.getContentPane().add(lblAlarma);
		
		lblHora = new JLabel("HORA");
		lblHora.setHorizontalAlignment(SwingConstants.CENTER);
		lblHora.setFont(new Font("Arial", Font.PLAIN, 13));
		lblHora.setBounds(196, 135, 100, 20);
		frame.getContentPane().add(lblHora);		
		
		lblIdVago = new JLabel("ID VAGÓ");
		lblIdVago.setHorizontalAlignment(SwingConstants.CENTER);
		lblIdVago.setFont(new Font("Arial", Font.PLAIN, 13));
		lblIdVago.setBounds(98, 135, 100, 20);
		frame.getContentPane().add(lblIdVago);
		
		table = new JTable();
		table.setFillsViewportHeight(true);
		table.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		table.setFont(new Font("Arial", Font.PLAIN, 14));
		table.setModel(new DefaultTableModel(
			new Object[][] {
				{null, null, null, null, null, null},
				{null, null, null, null, null, null},
			},
			new String[] {
				"ID VAG\u00D3", "HORA DADES", "TEMPERATURA", "LLUM", "PORTA", "ALARMA"
			}
		) {
			Class[] columnTypes = new Class[] {
				String.class, String.class, String.class, String.class, String.class, String.class
			};
			public Class getColumnClass(int columnIndex) {
				return columnTypes[columnIndex];
			}
		});
		table.getColumnModel().getColumn(0).setResizable(false);
		table.getColumnModel().getColumn(0).setPreferredWidth(100);
		table.getColumnModel().getColumn(0).setMaxWidth(200);
		table.getColumnModel().getColumn(1).setResizable(false);
		table.getColumnModel().getColumn(1).setPreferredWidth(100);
		table.getColumnModel().getColumn(1).setMaxWidth(200);
		table.getColumnModel().getColumn(2).setResizable(false);
		table.getColumnModel().getColumn(2).setPreferredWidth(100);
		table.getColumnModel().getColumn(2).setMaxWidth(200);
		table.getColumnModel().getColumn(3).setResizable(false);
		table.getColumnModel().getColumn(3).setPreferredWidth(100);
		table.getColumnModel().getColumn(3).setMaxWidth(200);
		table.getColumnModel().getColumn(4).setResizable(false);
		table.getColumnModel().getColumn(4).setPreferredWidth(100);
		table.getColumnModel().getColumn(4).setMinWidth(100);
		table.getColumnModel().getColumn(4).setMaxWidth(200);
		table.getColumnModel().getColumn(5).setResizable(false);
		table.getColumnModel().getColumn(5).setPreferredWidth(100);
		table.getColumnModel().getColumn(5).setMaxWidth(200);
		table.setBounds(98, 156, 588, 203);
		frame.getContentPane().add(table);

		
		//Botó per SOTIR de l'aplicatiu
		btnNewButton = new JButton("Sortir");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				System.exit(0);
			}
		});
		btnNewButton.setBounds(724, 568, 89, 23);
		frame.getContentPane().add(btnNewButton);	
		
		JLabel lblIdEstaci = new JLabel("ID ESTACI\u00D3");
		lblIdEstaci.setHorizontalAlignment(SwingConstants.LEFT);
		lblIdEstaci.setFont(new Font("Arial", Font.BOLD | Font.ITALIC, 14));
		lblIdEstaci.setBounds(10, 61, 100, 20);
		frame.getContentPane().add(lblIdEstaci);
		
		textField_1 = new JTextField();
		textField_1.setText("127");
		textField_1.setHorizontalAlignment(SwingConstants.CENTER);
		textField_1.setFont(new Font("Arial", Font.BOLD | Font.ITALIC, 15));
		textField_1.setEditable(false);
		textField_1.setColumns(10);
		textField_1.setBounds(108, 61, 90, 20);
		frame.getContentPane().add(textField_1);
		
		txtDades = new JTextField();
		txtDades.setForeground(Color.RED);
		txtDades.setEditable(false);
		txtDades.setHorizontalAlignment(SwingConstants.CENTER);
		txtDades.setFont(new Font("Arial", Font.BOLD | Font.ITALIC, 16));
		txtDades.setColumns(10);
		txtDades.setBounds(102, 385, 588, 83);
		txtDades.setVisible(false);
		frame.getContentPane().add(txtDades);		
	}

	
	//////////////////////////////////////////////////////////////////
	/// METODES D'ACCÉS AL JTable
	//////////////////////////////////////////////////////////////////	
	public JTable getTable() {		
		return table;
	}
	
	// modifiquem el valor del vagó
	public void setIdVago(String vag){
		table.getModel().setValueAt(vag, 1, 0); // ID Vagó		
	}
	
	// modifiquem el valor de l'hora
	public void setHora(String h){
		table.getModel().setValueAt(h, 1, 1); // Hora		
	}	
	
	// modifiquem el valor de l'hora
	public void setTemp(String t){
		table.getModel().setValueAt(t, 1, 2); // Temperatura		
	}	
	
	// modifiquem el valor de Llum
	public void setLlum(String l){
		table.getModel().setValueAt(l, 1, 3); // Llum		
	}		
	
	// modifiquem el valor de Porta
	public void setPorta(String port){
		table.getModel().setValueAt(port, 1, 4); // Porta		
	}		

	// modifiquem el valor d'Alarma
	public void setAlarma(String alarm){
		table.getModel().setValueAt(alarm, 1, 5); // Alarma		
	}
	
	public void setComboi(String combo){ // Identificador del Comboi
		textComboi.setText(combo);
	}
	
	//Mostrem el missatge de Rebent dades
	public void setMsgDades(int motacomid){
		txtDades.setText("REBENT DADES DEL COMBOI:  " + motacomid);
		txtDades.setVisible(true);
		frame.getContentPane().repaint();
	}

	//Mostrem el missatge de Rebent dades
	public void getMsgDades(){
			txtDades.setVisible(false);
			frame.getContentPane().repaint();	
	}		
	
}
